//
//  ICRQSingleSelectViewController.m
//  Cruiser
//
//  Created by Xummer on 6/7/15.
//  Copyright (c) 2015 Xummer. All rights reserved.
//

#import "ICRSingleScoreViewController.h"
#import "ICRQuestionManager.h"

static NSString *kCellID = @"cellID";

@interface ICRSingleScoreViewController ()
<
UITableViewDataSource,
UITableViewDelegate
>

@property (strong, nonatomic) IBTTableView *m_tableView;
@property (strong, nonatomic) NSIndexPath *m_currentIndexP;

@end

@implementation ICRSingleScoreViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    for (NSDictionary *dict in self.m_answer.details) {
        NSIndexPath *indexP =
        [NSIndexPath indexPathForRow:[dict[ @"index" ] unsignedIntegerValue] inSection:0];
        self.m_currentIndexP = indexP;
        [_m_tableView selectRowAtIndexPath:indexP animated:NO scrollPosition:UITableViewScrollPositionNone];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Private Method

- (void)initScrollViewWithRect:(CGRect)rect {//重写父类的方法
    
    self.m_tableView = [[IBTTableView alloc] initWithFrame:rect style:UITableViewStylePlain];
    _m_tableView.bHandleKeyboard = YES;
    _m_tableView.backgroundColor = [UIColor clearColor];
    _m_tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [_m_tableView registerClass:[IBTTableViewCell class] forCellReuseIdentifier:kCellID];
    _m_tableView.dataSource = self;
    _m_tableView.delegate = self;
    
    self.m_contentScrollView = _m_tableView;
    [self.view addSubview:_m_tableView];
    if (self.d_notEdit) {
        self.m_tableView.userInteractionEnabled = NO;
    }
}

#pragma mark - UITableViewDataSource

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView
 numberOfRowsInSection:(NSInteger)section
{
    return self.m_arrOptions.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView
         cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:kCellID forIndexPath:indexPath];
    cell.backgroundColor = [UIColor clearColor];
    [self configureCell:cell forRowAtIndexPath:indexPath];
    
    if (self.m_currentIndexP && self.m_currentIndexP.row == indexPath.row) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }
    else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    return cell;
}

- (void)configureCell:(UITableViewCell *)cell
    forRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSDictionary *dicOptionItem = self.m_arrOptions[ indexPath.row ];
    cell.textLabel.text =[NSString stringWithFormat:@"%@ .%@:  %@分",[GTOCommonTools stringLetterWithNumber:indexPath.row],dicOptionItem[@"value"],dicOptionItem[ @"score" ]] ;
}

#pragma mark - UITableViewDelegate

- (void)tableView:(UITableView *)tableView
didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:self.m_currentIndexP];
    cell.accessoryType = UITableViewCellAccessoryNone;
    
    self.m_currentIndexP = indexPath;
    
    cell = [tableView cellForRowAtIndexPath:self.m_currentIndexP];
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
    
    NSDictionary *dicOptionItem = self.m_arrOptions[ indexPath.row ];
    NSString *deUuid = [NSString string];
    if (self.m_answer.details.count > 0) {
        NSDictionary *dict = self.m_answer.details[0];
        ICRAnswerDetail *dE = [ICRAnswerDetail DBObject];
        [dE praseFromJsonDict:dict];
        deUuid = dE.uuid;
    }
    ICRAnswerDetail *dE = [ICRAnswerDetail DBObject];
    if (deUuid.length > 0) {
        dE.uuid = deUuid;
    } else {
        dE.uuid = [[ICRUserUtil sharedInstance] mobileID];//随机生成的唯一标识
    }
    dE.index = [dicOptionItem[ @"index" ] unsignedIntegerValue];
    dE.numberValue = [dicOptionItem[ @"score" ] unsignedIntegerValue];
    dE.stringValue = dicOptionItem[ @"value" ] ;
    self.m_answer.details = @[ [dE dictForCommit] ];
}

#pragma mark - Actions
- (void)onNextBtnAction:(__unused id)sender {
    if (self.d_notEdit) {
        [super disMissSelf];
        return;
    }
    if ([self.m_answer.details count] <= 0) {
        self.m_answer.bIsAnswered = NO;
        return;
    }
    
    self.m_answer.bIsAnswered = YES;
    self.m_answer.remark = self.m_helperView.m_inputTxtF.text;
    ICRQuestionManager *mgr = [ICRQuestionManager sharedManager];
    UIViewController *qVC = [mgr questionViewControlAtIndex:self.m_uiIndex + 1];
    if (qVC) {
        [self PushViewController:qVC animated:YES];
    }
    else {
        [super disMissSelf];
//        [self openResultView];
    }
    [self.m_answer saveToDBWithHandleData:NULL complete:NULL fail:NULL];
}

@end
